﻿Imports System.Runtime.InteropServices
Imports System
Imports System.Text

' Please read the included file "important_notes_for_NET_developers_on_using_WSQ_image_library.html"
' or the page: 
' http://cognaxon.com/index.php?page=wsqlib_NETnotes
' FAQ (Frequently Asked Questions)
' for .NET developers on using WSQ image library


Public Class Form1


    Dim hbitmap As IntPtr

    Private WSQ_library_native_methods As WSQImageLibraryNativeMethods
    Private input_data_stream As Byte()
    Private input_data_stream2 As Byte()
    Private output_data_stream As Byte()
    Private output_data_stream2 As Byte()
    Private pwidth As Int64
    Private pheight As Int64
    Private ppi As Int64
    Private comment_text As String
    Private bitrate As Double
	Private utf8 As New UTF8Encoding


    'To call functions from WSQ_library.dll
    'you can use the methods from wrapper class WSQImageLibraryNativeMethods
    'or you can use function prototypes provided below 

    <DllImport("WSQ_library64.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Unicode)> _
    Shared Function CreateBMPFromFile(ByVal FileName As Byte()) As IntPtr
    End Function

    <DllImport("WSQ_library64.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Unicode)> _
    Shared Function SaveBMPToFile(ByVal hBitmap As IntPtr, ByVal FileName As Byte(), ByVal ifiletype As Short) As Int64
    End Function

    <DllImport("WSQ_library64.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Unicode)> _
    Shared Sub RegisterWSQ()
    End Sub

    <DllImport("WSQ_library64.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Unicode)> _
    Shared Sub SetShowFilePropertiesDialog(ByVal file_properties_dialog As Int64)
    End Sub

    <DllImport("WSQ_library64.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Unicode)> _
    Shared Sub ShowFileConverter()
    End Sub

    <DllImport("WSQ_library64.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Unicode)> _
    Shared Function ConvertHBITMAPtoGrayScale256(ByVal hBitmap As IntPtr) As IntPtr
    End Function

    <DllImport("WSQ_library64.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Unicode)> _
    Shared Function SaveHBITMAPtoFileAsGrayScale256BMP(ByVal hBitmap As IntPtr, ByVal FileName As Byte()) As Int64
    End Function


    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        comment_text = String.Empty 'need to initialize comment_text in order to avoid crashing

        WSQ_library_native_methods = New WSQImageLibraryNativeMethods

    End Sub

    Private Sub ButtonOpen_Click(sender As Object, e As EventArgs) Handles ButtonOpen.Click

        Static hbitmap As IntPtr = IntPtr.Zero

        Dim OpenFileDialog1 As OpenFileDialog = New OpenFileDialog
        OpenFileDialog1.Filter = "All images|*.wsq;*.bmp;*.tiff;*.tif;*.jpg;*.jpeg;*.jp2;*.jpc;" & _
"*.png;*.gif;*.tga;*.pcx;*.ppm;*.pgm;*.pbm;*.ico;*.wmf;*.wbmp;*.ska;*.mng;*.pnm;*.ras;*.raw;|" & _
"FBI's Wavelet Scalar Quantization (*.wsq)|*.wsq|" & _
"Windows Bitmap Graphics (*.bmp)|*.bmp|" & _
"Macintosh Tagged Information File Format images (*.tiff)|*.tiff|" & _
"PC Tagged Information File Format images (*.tif)|*.tif|" & _
"Joint Photographic Experts Group images (*.jpg)|*.jpg|" & _
"Joint Photographic Experts Group images (*.jpeg)|*.jpeg|" & _
"JPEG2000 Part 1 images (*.jp2)|*.jp2|" & _
"JPEG2000 Code Stream images (*.jpc)|*.jpc|" & _
"Portable Network Graphics images (*.png)|*.png|" & _
"Compuserve Graphic Interchange Format images (*.gif)|*.gif|" & _
"Truevision Targa Graphic images (*.tga )|*.tga|" & _
"ZSoft Paintbrush images (PC Paintbrush Bitmap Graphic) (*.pcx)|*.pcx|" & _
"Portable Pixel Map Images (*.ppm)|*.ppm|" & _
"Portable Gray Map Images (*.pgm)|*.pgm|" & _
"Portable Bitmap Images (*.pbm)|*.pbm|" & _
"Windows Icons (*.ico)|*.ico|" & _
"Windows Metafiles (*.wmf)|*.wmf|" & _
"Wireless Bitmap File Format (*.wbmp)|*.wbmp|" & _
"SKA Format images (*.ska)|*.ska|" & _
"Muti-image Network Graphic Animation (*.mng)|*.mng|" & _
"PBM Portable Any Map Graphic Bitmap (*.pnm)|*.pnm|" & _
"Sun Graphic (*.ras)|*.ras|" & _
"RAW Graphic (*.raw)|*.raw"

        OpenFileDialog1.FilterIndex = 1

        If (OpenFileDialog1.ShowDialog() <> DialogResult.OK) Then
            Exit Sub
        End If


        'you can use commented line of code bellow or you can use method from class WSQ_library_native_methods
        'hbitmap = CreateBMPFromFile(utf8.GetBytes(OpenFileDialog1.FileName))
        hbitmap = WSQ_library_native_methods.pCreateBMPFromFile(OpenFileDialog1.FileName)
        OutputPicture.Image = Bitmap.FromHbitmap(hbitmap)

        pheight = OutputPicture.Image.Height
        pwidth = OutputPicture.Image.Width
        OutputPicture.SetBounds(0, 0, pwidth, pheight)

        ButtonSave.Enabled = True

    End Sub

    Private Sub ButtonSave_Click(sender As Object, e As EventArgs) Handles ButtonSave.Click

        Dim iResult As Short

        Dim SaveFileDialog1 As SaveFileDialog = New SaveFileDialog
        ' Set filters.
        SaveFileDialog1.Filter = "WSQ Files (*.wsq)|*.wsq|" &
"Windows BMP (*.bmp)|*.bmp|" &
"TIFF Files (*.tif)|*.tif|" &
"PNG Files (*.png)|*.png|" &
"JPEG Files (*.jpg)|*.jpg|" &
"Targa Files (*.tga)|*.tga|" &
"SGI Files (*.rgb)|*.rgb|" &
"JPEG-2000 Part-1 (*.jp2)|*.jp2|" &
"JPEG-2000 Code Stream (*.jpc)|*.jpc|" &
"PBM - Portable Bitmap Format (*.pbm)|*.pbm|" &
"PGM - Portable Graymap Format (*.pgm)|*.pgm|" &
"PPM - Portable Pixmap Format (*.ppm)|*.ppm|" &
"GIF Files (*.gif)|*.gif|" &
"PNM Files (*.pnm)|*.pnm|" &
"RAS Files (*.ras)|*.ras|" &
"MNG Files (*.mng)|*.mng|" &
"PCX Files (*.pcx)|*.pcx"


        ' Specify default filter.
        SaveFileDialog1.FilterIndex = 1

        SaveFileDialog1.FileName = ""


        If (SaveFileDialog1.ShowDialog() <> DialogResult.OK) Then
            Exit Sub
        End If


        'you can use commented line of code bellow or you can use method from class WSQ_library_native_methods
        'SetShowFilePropertiesDialog(1)
        WSQ_library_native_methods.pSetShowFilePropertiesDialog(1)

        'you can use commented line of code bellow or you can use method from class WSQ_library_native_methods
        'iResult = SaveBMPToFile((New Bitmap(OutputPicture.Image)).GetHbitmap(), utf8.GetBytes(SaveFileDialog1.FileName), SaveFileDialog1.FilterIndex)
        iResult = WSQ_library_native_methods.pSaveBMPToFile((New Bitmap(OutputPicture.Image)).GetHbitmap(), SaveFileDialog1.FileName, SaveFileDialog1.FilterIndex)

        'Dim objBitmap As Bitmap
        'objBitmap = OutputPicture.Image
        'iResult = SaveBMPToFile(objBitmap.GetHbitmap(), SaveFileDialog1.FileName, SaveFileDialog1.FilterIndex)

    End Sub

    Private Sub ButtonRegister_Click(sender As Object, e As EventArgs) Handles ButtonRegister.Click

        'you can use commented line of code bellow or you can use method from class WSQ_library_native_methods
        'RegisterWSQ()
        WSQ_library_native_methods.pRegisterWSQ()

    End Sub

    Private Sub buttonWSQtoStream_Click(sender As Object, e As EventArgs) Handles buttonWSQtoStream.Click

        Static hbitmap As IntPtr = IntPtr.Zero

        Dim OpenFileDialog1 As OpenFileDialog = New OpenFileDialog
        OpenFileDialog1.Filter = "FBI Wavelet Scalar Quantization (*.wsq)|*.wsq"
        OpenFileDialog1.FilterIndex = 1

        If (OpenFileDialog1.ShowDialog <> DialogResult.OK) Then
            Exit Sub
        End If

        Dim fInfo As IO.FileInfo = New IO.FileInfo(OpenFileDialog1.FileName)
        Dim input_stream_length As Long = fInfo.Length
        Dim fStream As IO.FileStream = New IO.FileStream(OpenFileDialog1.FileName, IO.FileMode.Open, IO.FileAccess.Read)
        Dim br As IO.BinaryReader = New IO.BinaryReader(fStream)

        'force garbage collection of .Net objects:
        'GC.Collect()
        'GC.WaitForPendingFinalizers()
        'GC.Collect()

        input_data_stream = br.ReadBytes(input_stream_length)
        WSQ_library_native_methods.pWSQ_decode_stream(input_data_stream, input_stream_length, output_data_stream,
                pwidth, pheight, ppi, comment_text)

        Dim output_data_stream_length As Integer = pheight * pwidth


        'Converts WSQ compressed byte array into HBITMAP for showing on screen
        hbitmap = WSQ_library_native_methods.pCreateBMPFromWSQByteArray(input_data_stream, input_stream_length)
        OutputPicture.Image = Bitmap.FromHbitmap(hbitmap)

        pheight = OutputPicture.Image.Height
        pwidth = OutputPicture.Image.Width
        OutputPicture.SetBounds(0, 0, pwidth, pheight)

        ' Saves WSQ compressed byte array to an image file.
        'WSQ_library_native_methods.pSaveWSQByteArrayToImageFile(input_data_stream, input_stream_length, "C:\\OutputDirectory\\output.jpg", 5)


        MsgBox("WSQ file was loaded into memory stream and decompressed into another memory stream." & vbCrLf &
            "Now please press button " & ControlChars.Quote & "stream -> WSQ" & ControlChars.Quote &
            " to compress memory stream and save it to file." & vbCrLf &
            "WSQ compressed byte array was converted to HBITMAP for showing on screen.")

        br.Close()
        fStream.Close()

        ButtonStreamToWSQ.Enabled = True

    End Sub

    Private Sub ButtonStreamToWSQ_Click(sender As Object, e As EventArgs) Handles ButtonStreamToWSQ.Click


        Dim SaveFileDialog1 As SaveFileDialog = New SaveFileDialog
        SaveFileDialog1.Filter = "WSQ Files (*.wsq)|*.wsq"
        SaveFileDialog1.FilterIndex = 1
        If (SaveFileDialog1.ShowDialog <> DialogResult.OK) Then
            Exit Sub
        End If

        bitrate = 0.75
        ppi = 500
        comment_text = "Cognaxon"

        ReDim input_data_stream2(pwidth * pheight)

        Dim row, row2, pixel_number, pixel_number2 As Integer

        'MAKE A MIRRORED/FLIPPED IMAGE (UP<->DOWN and LEFT<->RIGHT)
        For y As Integer = 0 To pheight - 1 Step 1
            row = pwidth * y
            row2 = pwidth * (pheight - y - 1)

            For x As Integer = 0 To pwidth - 1 Step 1
                pixel_number = row + x
                pixel_number2 = row2 + (pwidth - x - 1)
                input_data_stream2(pixel_number2) = output_data_stream(pixel_number)
            Next x
        Next y

        Dim compressedLength As Integer

        WSQ_library_native_methods.pWSQ_encode_stream(input_data_stream2, pwidth, pheight,
            bitrate, ppi, comment_text, output_data_stream2, compressedLength)

        Dim fStream As IO.FileStream = New IO.FileStream(SaveFileDialog1.FileName, IO.FileMode.Create)
        Dim bw As IO.BinaryWriter = New IO.BinaryWriter(fStream)

        bw.Write(output_data_stream2)

        bw.Close()
        fStream.Close()

        MsgBox("Memory stream was compressed into another memory stream and saved to WSQ file." & vbCrLf &
           "Now please press button " & ControlChars.Quote & "Open" & ControlChars.Quote &
           ", select the saved file, open it and have a look at the" & vbCrLf &
           "results of memory stream processing. The processed image is mirrored/flipped" & vbCrLf &
           "(UP<->DOWN and LEFT<->RIGHT).")

    End Sub



End Class
