Imports System.Text
Imports System.Runtime.InteropServices

Public Class WSQImageLibraryNativeMethods

    Dim wsq_decompressed_byte_array_ptr As IntPtr = IntPtr.Zero
	Dim out_comment_text_ptr As IntPtr = IntPtr.Zero
    Dim wsq_compressed_byte_array_ptr As IntPtr = IntPtr.Zero
    Dim bitmap_ptr As IntPtr = IntPtr.Zero
    Dim serial_number_ptr As IntPtr = IntPtr.Zero


    Private utf8 As New UTF8Encoding



    <DllImport("WSQ_library64.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Unicode)> Private Shared Function GenerateWSQLibrarySerialNumber() As IntPtr
    End Function
    Public Function pGenerateWSQLibrarySerialNumber() As IntPtr

        Try
            serial_number_ptr = GenerateWSQLibrarySerialNumber()
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.OkOnly, "GenerateWSQLibrarySerialNumber Exception")
        End Try
        pGenerateWSQLibrarySerialNumber = serial_number_ptr
    End Function



    <DllImport("WSQ_library64.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Unicode)> Private Shared Function UnlockWSQLibrary(ByVal unlock_code As Byte()) As Int64
    End Function
    Public Function pUnlockWSQLibrary(ByVal unlock_code_string As String) As Int64

        Dim retVal As Int64 = -1

        If (unlock_code_string = Nothing) Then
            Throw (New ArgumentNullException("unlock_code_string should be not null"))
        ElseIf (unlock_code_string.Length = 0) Then
            Throw New ArgumentException("Error: output_decompressed_byte_array_length of unlock_code_string is 0")
        End If
        Try
            retVal = UnlockWSQLibrary(utf8.GetBytes(unlock_code_string))
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.OkOnly, "UnlockWSQLibrary Exception")
        End Try
        pUnlockWSQLibrary = retVal
    End Function



    <DllImport("WSQ_library64.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Unicode)> Private Shared Sub RegisterWSQ()
    End Sub
    Public Sub pRegisterWSQ()
        Try
            RegisterWSQ()
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.OkOnly, "RegisterWSQ Exception")
        End Try
    End Sub


    <DllImport("WSQ_library64.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Unicode)> Private Shared Function CreateBMPFromFile(ByVal lpszFileName As Byte()) As IntPtr
    End Function
    Public Function pCreateBMPFromFile(ByVal FileName As String) As IntPtr

        If (FileName = Nothing) Then
            Throw (New ArgumentNullException("FileName should be not null"))
        ElseIf (FileName.Length = 0) Then
            Throw New ArgumentException("Incorrect file name")
        End If
        Try
            bitmap_ptr = CreateBMPFromFile(utf8.GetBytes(FileName))
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.OkOnly, "CreateBMPFromFile Exception")
        End Try
        pCreateBMPFromFile = bitmap_ptr
    End Function


    <DllImport("WSQ_library64.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Unicode)> Private Shared Function SaveBMPToFile(ByVal hBitmap As IntPtr, _
            ByVal filename As Byte(), <MarshalAs(UnmanagedType.I8)> ByVal filetype As Int64) As Int64
    End Function
    Public Function pSaveBMPToFile(ByVal Bitmap As IntPtr, ByVal FileName As String, ByVal FileType As Int64) As Int64
        Dim retVal As Int64 = -1
        If (IsNothing(Bitmap) Or (FileName = Nothing)) Then
            Throw New ArgumentNullException("Bitmap and FileName should be not null")
        End If
        If (FileName.Length = 0) Then
            Throw New ArgumentException("Incorrect file name")
        End If
        Try
            retVal = SaveBMPToFile(Bitmap, utf8.GetBytes(FileName), FileType)
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.OkOnly, "SaveBMPToFile Exception")
        End Try
        pSaveBMPToFile = retVal
    End Function



    <DllImport("WSQ_library64.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Unicode)> Private Shared Function CreateBMPFromWSQByteArray( _
        <[In]()> ByVal input_wsq_compressed_byte_array As Byte(), _
        <MarshalAs(UnmanagedType.I8)> ByVal input_wsq_compressed_byte_array_length As Int64) As IntPtr
    End Function

    Public Function pCreateBMPFromWSQByteArray(<[In]()> ByVal input_wsq_compressed_byte_array As Byte(), _
              <[In]()> ByVal input_wsq_compressed_byte_array_length As Int64) As IntPtr
        Try
            bitmap_ptr = CreateBMPFromWSQByteArray(input_wsq_compressed_byte_array, input_wsq_compressed_byte_array_length)
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.OkOnly, "CreateBMPFromWSQByteArray Exception")
        End Try

        pCreateBMPFromWSQByteArray = bitmap_ptr

    End Function


    <DllImport("WSQ_library64.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Unicode)> Private Shared Function SaveWSQByteArrayToImageFile( _
        <[In]()> ByVal input_wsq_compressed_byte_array As Byte(), _
        <MarshalAs(UnmanagedType.I8)> ByVal input_wsq_compressed_byte_array_length As Int64, _
        ByVal lpszFileName As Byte(), _
        <MarshalAs(UnmanagedType.I8)> ByVal filetype As Int64) As Int64
    End Function
    Public Function pSaveWSQByteArrayToImageFile(<[In]()> ByVal input_wsq_compressed_byte_array As Byte(), _
              <[In]()> ByVal input_wsq_compressed_byte_array_length As Int64, ByVal FileName As String, ByVal FileType As Int64) As Int64

        Dim retVal As Int64 = -1

        Try
            retVal = SaveWSQByteArrayToImageFile(input_wsq_compressed_byte_array, input_wsq_compressed_byte_array_length, _
                    utf8.GetBytes(FileName), FileType)
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.OkOnly, "SaveWSQByteArrayToImageFile Exception")
        End Try

        pSaveWSQByteArrayToImageFile = retVal

    End Function


    <DllImport("WSQ_library64.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Unicode)> Private Shared Sub SetShowFilePropertiesDialog( _
            <MarshalAs(UnmanagedType.I8)> ByVal file_properties_dialog As Int64)
    End Sub
    Public Sub pSetShowFilePropertiesDialog(ByVal file_properties_dialog As Int64)
        Try
            SetShowFilePropertiesDialog(file_properties_dialog)
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.OkOnly, "SetShowFilePropertiesDialog Exception")
        End Try
    End Sub





    <DllImport("WSQ_library64.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Unicode)> Private Shared Sub ShowFileConverter()
    End Sub
    Public Sub pShowFileConverter()
        Try
            ShowFileConverter()
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.OkOnly, "ShowFileConverter Exception")
        End Try
    End Sub





    <DllImport("WSQ_library64.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Unicode)> Private Shared Function WSQ_decode_stream( _
        <[In]()> ByVal input_wsq_compressed_byte_array As Byte(), _
        <MarshalAs(UnmanagedType.I8)> ByVal input_wsq_compressed_byte_array_length As Int64, _
        ByRef output_decompressed_byte_array As IntPtr, _
        <MarshalAs(UnmanagedType.I8)> ByRef pwidth As Int64, _
        <MarshalAs(UnmanagedType.I8)> ByRef pheight As Int64, _
        <MarshalAs(UnmanagedType.I8)> ByRef ppi As Int64, _
        ByRef comment_text As IntPtr) As Int64
    End Function
    Public Function pWSQ_decode_stream(<[In]()> ByVal input_wsq_compressed_byte_array As Byte(), _
                <[In]()> ByVal input_wsq_compressed_byte_array_length As Int64, _
                ByRef output_decompressed_byte_array As Byte(), _
                ByRef pwidth As Int64, _
                ByRef pheight As Int64, _
                ByRef ppi As Int64, _
                ByRef comment_text As String) As Int64

        Dim retVal As Int64 = -1

        Try
            WSQ_decode_stream(input_wsq_compressed_byte_array, input_wsq_compressed_byte_array_length, _
                    wsq_decompressed_byte_array_ptr, pwidth, pheight, _
                    ppi, out_comment_text_ptr)


            comment_text = Marshal.PtrToStringAnsi(out_comment_text_ptr)
            Dim output_decompressed_byte_array_length As Int64 = pwidth * pheight
            ReDim output_decompressed_byte_array(output_decompressed_byte_array_length)
            Marshal.Copy(wsq_decompressed_byte_array_ptr, output_decompressed_byte_array, 0, Convert.ToInt32(output_decompressed_byte_array_length))
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.OkOnly, "WSQ_decode_stream Exception")
        End Try

        pWSQ_decode_stream = retVal

    End Function



    <DllImport("WSQ_library64.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Unicode)> Private Shared Function WSQ_encode_stream( _
        <[In]()> ByVal inputBuffer As Byte(), _
        <MarshalAs(UnmanagedType.I8)> ByVal width As Int64, _
        <MarshalAs(UnmanagedType.I8)> ByVal height As Int64, _
        <MarshalAs(UnmanagedType.R8)> ByVal bitrate As Double, _
        <MarshalAs(UnmanagedType.I8)> ByVal ppi As Int64, _
        <[In]()> ByVal comment_text As Byte(), _
        ByRef output_compressed_byte_array As IntPtr, _
        <MarshalAs(UnmanagedType.I8)> ByRef output_compressed_byte_array_length As Int64) As Int64
    End Function
    Public Function pWSQ_encode_stream( _
        ByVal inputBuffer As Byte(), _
        ByVal width As Int64, _
        ByVal height As Int64, _
        ByVal bitrate As Double, _
        ByVal ppi As Int64, _
        ByVal commentText As String, _
        ByRef output_compressed_byte_array As Byte(), _
        ByRef output_compressed_byte_array_length As Int64) As Int64


        Dim retVal As Int64 = -1

        Try
            WSQ_encode_stream(inputBuffer, width, height, _
                    bitrate, ppi, utf8.GetBytes(commentText), _
                    wsq_compressed_byte_array_ptr, output_compressed_byte_array_length)
            If (output_compressed_byte_array_length = 0) Then
                Throw New ArgumentException("output_compressed_byte_array_length == 0")
            End If
            ReDim output_compressed_byte_array(output_compressed_byte_array_length)
            Marshal.Copy(wsq_compressed_byte_array_ptr, output_compressed_byte_array, 0, Convert.ToInt32(output_compressed_byte_array_length))
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.OkOnly, "WSQ_encode_stream Exception")
        End Try

        pWSQ_encode_stream = retVal

    End Function


    <DllImport("WSQ_library64.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Unicode)> Private Shared Function ConvertHBITMAPtoGrayScale256(ByVal hBitmap As IntPtr) As IntPtr
    End Function
    Public Function pConvertHBITMAPtoGrayScale256(ByVal Bitmap As IntPtr) As IntPtr
        Try
            bitmap_ptr = ConvertHBITMAPtoGrayScale256(Bitmap)
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.OkOnly, "ConvertHBITMAPtoGrayScale256 Exception")
        End Try
        pConvertHBITMAPtoGrayScale256 = bitmap_ptr
    End Function


    <DllImport("WSQ_library64.dll", CallingConvention:=CallingConvention.Cdecl, CharSet:=CharSet.Unicode)> Private Shared Function SaveHBITMAPtoFileAsGrayScale256BMP(ByVal hBitmap As IntPtr, _
            ByVal filename As Byte()) As Int64
    End Function
    Public Function pSaveHBITMAPtoFileAsGrayScale256BMP(ByVal Bitmap As IntPtr, ByVal FileName As String) As Int64
        Dim retVal As Int64 = -1
        If (IsNothing(Bitmap) Or (FileName = Nothing)) Then
            Throw New ArgumentNullException("Bitmap and FileName should be not null")
        End If
        If (FileName.Length = 0) Then
            Throw New ArgumentException("Incorrect file name")
        End If
        Try
            retVal = SaveHBITMAPtoFileAsGrayScale256BMP(Bitmap, utf8.GetBytes(FileName))
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.OkOnly, "SaveHBITMAPtoFileAsGrayScale256BMP Exception")
        End Try
        pSaveHBITMAPtoFileAsGrayScale256BMP = retVal
    End Function



End Class
